package com.tidefactions.chat;

import org.bukkit.configuration.InvalidConfigurationException;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;

import static com.tidefactions.chat.Main.colorCodes;

public class Config {
    // Settings
    public static Boolean LOG_CHAT_TO_CONSOLE;

    // Channel prefixes
    public static String GLOBAL_CHANNEL_PREFIX;
    public static String STAFF_CHANNEL_PREFIX;
    public static String ADMIN_CHANNEL_PREFIX;
    public static String BUILDER_CHANNEL_PREFIX;
    public static String ALERT_CHANNEL_PREFIX;

    // Chat formats
    public static String GLOBAL_CHAT_FORMAT;
    public static String STAFF_CHAT_FORMAT;
    public static String ADMIN_CHAT_FORMAT;
    public static String BUILDER_CHAT_FORMAT;
    public static String ALERT_CHAT_FORMAT;

    // Name
    public static String NAME_PREFIX_FORMAT;
    public static String NAME_SUFFIX_FORMAT;

    // Console chat settings
    public static String CONSOLE_PREFIX;
    public static String CONSOLE_TITLE;
    public static String CONSOLE_NAME_COLOR;
    public static String CONSOLE_CHAT_COLOR;

    // Discord
    public static Boolean DISCORD_ENABLED;
    public static String DISCORD_ALERT_IMAGE;
    public static String DISCORD_ALERT_NAME;
    public static String DISCORD_CONSOLE_IMAGE;
    public static String DISCORD_PLAYER_IMAGE;
    public static String DISCORD_GLOBAL_WEBHOOK;
    public static String DISCORD_STAFF_WEBHOOK;
    public static String DISCORD_ADMIN_WEBHOOK;
    public static String DISCORD_BUILDER_WEBHOOK;
    public static String DISCORD_ALERT_WEBHOOK;

    public static void load(File file) {
        try {
            if (!file.getParentFile().exists())
                file.getParentFile().mkdirs();
            if (!file.exists())
                Main.ExportResource("/config.yml", file);
            YamlConfiguration config = new YamlConfiguration();
            config.load(file);

            // Settings
            LOG_CHAT_TO_CONSOLE = config.getBoolean("settings.log-chat-to-console");

            // Channel prefixes
            GLOBAL_CHANNEL_PREFIX = colorCodes(config.getString("prefixes.global"));
            STAFF_CHANNEL_PREFIX = colorCodes(config.getString("prefixes.staff"));
            ADMIN_CHANNEL_PREFIX = colorCodes(config.getString("prefixes.admin"));
            BUILDER_CHANNEL_PREFIX = colorCodes(config.getString("prefixes.builder"));
            ALERT_CHANNEL_PREFIX = colorCodes(config.getString("prefixes.alert"));

            // Chat formats
            GLOBAL_CHAT_FORMAT = colorCodes(config.getString("format.global"));
            STAFF_CHAT_FORMAT = colorCodes(config.getString("format.staff"));
            ADMIN_CHAT_FORMAT = colorCodes(config.getString("format.admin"));
            BUILDER_CHAT_FORMAT = colorCodes(config.getString("format.builder"));
            ALERT_CHAT_FORMAT = colorCodes(config.getString("format.alert"));


            // Nametag
            NAME_PREFIX_FORMAT = colorCodes(config.getString("name.prefix-format"));
            NAME_SUFFIX_FORMAT = colorCodes(config.getString("name.suffix-format"));

            // Console chat settings
            CONSOLE_PREFIX = colorCodes(config.getString("console.prefix"));
            CONSOLE_TITLE = colorCodes(config.getString("console.title"));
            CONSOLE_NAME_COLOR = colorCodes(config.getString("console.name-color"));
            CONSOLE_CHAT_COLOR = colorCodes(config.getString("console.chat-color"));

            // Discord
            DISCORD_ENABLED = config.getBoolean("discord.enable");
            DISCORD_ALERT_NAME = config.getString("discord.alert-name");
            DISCORD_ALERT_IMAGE = config.getString("discord.alert-image");
            DISCORD_CONSOLE_IMAGE = config.getString("discord.console-image");
            DISCORD_PLAYER_IMAGE = config.getString("discord.player-image");
            DISCORD_GLOBAL_WEBHOOK = config.getString("discord.webhooks.global");
            DISCORD_STAFF_WEBHOOK = config.getString("discord.webhooks.staff");
            DISCORD_ADMIN_WEBHOOK = config.getString("discord.webhooks.admin");
            DISCORD_BUILDER_WEBHOOK = config.getString("discord.webhooks.builder");
            DISCORD_ALERT_WEBHOOK = config.getString("discord.webhooks.alert");

        } catch (IOException | InvalidConfigurationException e) {
            e.printStackTrace();
        }
    }
}
