package com.tidefactions.chat.EventHandlers;

import com.tidefactions.chat.Config;
import com.tidefactions.chat.Events.MessageSendInChannelEvent;
import com.tidefactions.chat.Intergration.Discord;
import com.tidefactions.chat.Utils.ChatUtils;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.player.AsyncPlayerChatEvent;

public class ChatHandler implements Listener {

    @EventHandler(priority = EventPriority.HIGH)
    public void onAsyncChatEvent(AsyncPlayerChatEvent event) {
        if (event.isCancelled())
            return;

        Player player = event.getPlayer();
        ChatUtils.sendMessageInChannel(
                player,
                ChatUtils.getChatMode(player),
                event.getMessage(),
                "Chat");
        event.setCancelled(true);
        event.setMessage(ChatColor.RED + "[THIS EVENT WAS CANCELED BY CHAT]");
    }

    @EventHandler
    public void onMessageSendInChannelEvent(MessageSendInChannelEvent event) {
        if (Config.LOG_CHAT_TO_CONSOLE) {
            String finalMessage;
            if (event.getPlayer().equals("CONSOLE")) {
                finalMessage = ChatUtils.getMessageForChannelAsConsole(
                        event.getChatMode(),
                        event.getMessage());
            } else {
                finalMessage = ChatUtils.getMessageForChannel(
                        Bukkit.getPlayer(event.getPlayer()),
                        event.getChatMode(),
                        event.getMessage());
            }
            Bukkit.getConsoleSender().sendMessage("[CHAT] " + finalMessage);
        }
        if (Config.DISCORD_ENABLED) {
            Discord.forward(event);
        }
    }
}
