package com.tidefactions.chat.Intergration;

import com.tidefactions.chat.Config;
import com.tidefactions.chat.Events.MessageSendInChannelEvent;
import com.tidefactions.chat.Types.ChatMode;
import org.bukkit.Bukkit;
import org.json.simple.JSONObject;

import javax.net.ssl.HttpsURLConnection;
import java.io.DataOutputStream;
import java.io.OutputStreamWriter;
import java.net.URL;

public class Discord {

    @SuppressWarnings("all")
    public static void forward(MessageSendInChannelEvent event) {
        System.out.println("Forwarding message from " + event.getPlayer() + " to discord.");
        if (event.getChatMode().getWebhook() != null && !event.getChatMode().getWebhook().equals("")) {
            try {
                // Open connection
                URL url = new URL(event.getChatMode().getWebhook());
                HttpsURLConnection conn = (HttpsURLConnection) url.openConnection();

                // Set properties
                conn.setDoOutput(true);
                conn.setDoInput(true);
                conn.setRequestMethod("POST");
                conn.setRequestProperty("User-Agent", "Mozilla/5.0 (X11; Linux x86_64; rv:49.0) Gecko/20100101 Firefox/49.0");
                conn.setRequestProperty("Content-Type", "application/json; charset=utf-8");

                // Create JSON data
                JSONObject data = new JSONObject();
                data.put("username", event.getChatMode() == ChatMode.ALERT ?
                        Config.DISCORD_ALERT_NAME :
                        event.getPlayer());
                data.put("avatar_url", event.getChatMode() == ChatMode.ALERT ?
                        Config.DISCORD_ALERT_IMAGE :
                        event.getPlayer() == "CONSOLE" ?
                                Config.DISCORD_CONSOLE_IMAGE :
                                Config.DISCORD_PLAYER_IMAGE.replaceAll("<UUID>",
                                        Bukkit.getPlayer(event.getPlayer()).getUniqueId().toString()));
                data.put("content", event.getMessage());

                // Send data
                conn.setRequestProperty("Content-length", String.valueOf(data.toString().length()));
                DataOutputStream stream = new DataOutputStream(conn.getOutputStream());
                stream.writeBytes(data.toString());
                stream.flush();
                stream.close();
                conn.getResponseMessage();
            } catch (Exception e) {
                System.out.println("There was a problem forwarding chat to discord. Is the webhook url correct?");
            }
        }
    }
}
